libglom-1.26 1.28.5

- Main Page
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Public Attributes | List of all members
Glom::LayoutGroup Class Reference
Inheritance diagram for Glom::LayoutGroup:
[legend]
Collaboration diagram for Glom::LayoutGroup:
[legend]

## Public Types
typedef std::vector< sharedptr< LayoutItem > > | type_list_items
typedef std::vector< sharedptr< const LayoutItem > > | type_list_const_items
Public Types inherited from Glom::TranslatableItem
enum | enumTranslatableItemType { TRANSLATABLE_TYPE_INVALID, TRANSLATABLE_TYPE_FIELD, TRANSLATABLE_TYPE_RELATIONSHIP, TRANSLATABLE_TYPE_LAYOUT_ITEM, TRANSLATABLE_TYPE_CUSTOM_TITLE, TRANSLATABLE_TYPE_PRINT_LAYOUT, TRANSLATABLE_TYPE_REPORT, TRANSLATABLE_TYPE_TABLE, TRANSLATABLE_TYPE_BUTTON, TRANSLATABLE_TYPE_TEXTOBJECT, TRANSLATABLE_TYPE_IMAGEOBJECT, TRANSLATABLE_TYPE_CHOICEVALUE, TRANSLATABLE_TYPE_DATABASE_TITLE, TRANSLATABLE_TYPE_STATIC_TEXT }
typedef std::map< Glib::ustring, Glib::ustring > | type_map_locale_to_translations

## Public Member Functions
| LayoutGroup ()
| LayoutGroup (const LayoutGroup& src)
LayoutGroup& | operator= (const LayoutGroup& src)
virtual | ~LayoutGroup ()
virtual LayoutItem* | clone () const
| Create a new copied instance. More...
bool | has_field (const Glib::ustring& parent_table_name, const Glib::ustring& table_name, const Glib::ustring& field_name) const
| Discover whether the layout group contains the specified field (from the current table). More...
bool | has_any_fields () const
| Discover whether the layout group contains any fields. More...
void | add_item (const sharedptr< LayoutItem >& item)
| Add the item to the end of the list. More...
void | add_item (const sharedptr< LayoutItem >& item, const sharedptr< const LayoutItem >& position)
| Add the item after the specified existing item. More...
void | remove_item (const sharedptr< LayoutItem >& item)
| Remove a layout item from the group. More...
void | remove_field (const Glib::ustring& parent_table_name, const Glib::ustring& table_name, const Glib::ustring& field_name)
| Remove any instance of the field from the layout. More...
virtual void | change_field_item_name (const Glib::ustring& table_name, const Glib::ustring& field_name, const Glib::ustring& field_name_new)
virtual void | change_related_field_item_name (const Glib::ustring& table_name, const Glib::ustring& field_name, const Glib::ustring& field_name_new)
virtual void | remove_relationship (const sharedptr< const Relationship >& relationship)
| Remove any use of the relationship from the layout. More...
void | remove_all_items ()
double | get_border_width () const
void | set_border_width (double border_width)
guint | get_items_count () const
guint | get_columns_count () const
void | set_columns_count (guint columns_count)
type_list_items | get_items ()
type_list_const_items | get_items () const
type_list_const_items | get_items_recursive () const
| Get the items recursively, depth-first, not returning any groups. More...
type_list_items | get_items_recursive ()
| Get the items recursively, depth-first, not returning any groups. More...
type_list_const_items | get_items_recursive_with_groups () const
| Get the items recursively, depth-first, also returning the groups. More...
virtual Glib::ustring | get_part_type_name () const
virtual Glib::ustring | get_report_part_id () const
| Gets the node name to use for the intermediate XML, (and usually, the CSS style class to use for the resulting HTML). More...
Public Member Functions inherited from Glom::LayoutItem
| LayoutItem ()
| LayoutItem (const LayoutItem& src)
LayoutItem& | operator= (const LayoutItem& src)
virtual | ~LayoutItem ()
bool | operator== (const LayoutItem& src) const
virtual bool | get_editable () const
virtual void | set_editable (bool val=true)
virtual Glib::ustring | get_layout_display_name () const
guint | get_display_width () const
void | set_display_width (guint value)
void | get_print_layout_position (double& x, double& y, double& width, double& height) const
| This is used only for the print layouts. More...
void | set_print_layout_position (double x, double y, double width, double height)
| This is used only for the print layouts. More...
void | set_print_layout_position_y (double y)
| This is used only for the print layouts. More...
void | set_print_layout_split_across_pages (bool split=true)
| This is used only for the print layouts. More...
bool | get_print_layout_split_across_pages () const
| This is used only for the print layouts. More...
Public Member Functions inherited from Glom::TranslatableItem
| TranslatableItem ()
| TranslatableItem (const TranslatableItem& src)
virtual | ~TranslatableItem ()
TranslatableItem& | operator= (const TranslatableItem& src)
bool | operator== (const TranslatableItem& src) const
bool | operator!= (const TranslatableItem& src) const
virtual void | set_name (const Glib::ustring& name)
| Set the non-translated identifier name. More...
virtual Glib::ustring | get_name () const
| Get the non-translated identifier name. More...
bool | get_name_not_empty () const
virtual Glib::ustring | get_title_or_name (const Glib::ustring& locale) const
virtual Glib::ustring | get_title (const Glib::ustring& locale) const
| Get the title's translation for the specified locale, falling back to the original text if there is no translation. More...
virtual Glib::ustring | get_title_original () const
| Get the title's original (non-translated, usually English) text. More...
Glib::ustring | get_title_translation (const Glib::ustring& locale, bool fallback=true) const
| Get the title's translation for the specified locale, optionally falling back to a locale of the same language, and then falling back to the original. More...
void | set_title (const Glib::ustring& title, const Glib::ustring& locale)
| Set the title's translation for the specified locale. More...
void | set_title_original (const Glib::ustring& title)
| Set the title's original (non-translated, usually English) text. More...
void | clear_title_in_all_locales ()
| Clear the original title and any translations of the title. More...
bool | get_has_translations () const
enumTranslatableItemType | get_translatable_item_type () const

## Public Attributes
type_list_items | m_list_items

## Additional Inherited Members
Static Public Member Functions inherited from Glom::TranslatableItem
static Glib::ustring | get_translatable_type_name (enumTranslatableItemType item_type)
static Glib::ustring | get_translatable_type_name_nontranslated (enumTranslatableItemType item_type)
| The non-translated name is used for the context in gettext .po files. More...
Protected Attributes inherited from Glom::TranslatableItem
enumTranslatableItemType | m_translatable_item_type

## Member Typedef Documentation

typedef std::vector< sharedptr<const LayoutItem> > Glom::LayoutGroup::type_list_const_items

typedef std::vector< sharedptr<LayoutItem> > Glom::LayoutGroup::type_list_items

## Constructor & Destructor Documentation

Glom::LayoutGroup::LayoutGroup | ( |  | ) |

Glom::LayoutGroup::LayoutGroup | ( | const LayoutGroup& | src | ) |

virtual Glom::LayoutGroup::~LayoutGroup | ( |  | ) |
| virtual

## Member Function Documentation

void Glom::LayoutGroup::add_item | ( | const sharedptr< LayoutItem >& | item | ) |

Add the item to the end of the list.

Parameters

  item | The item to add.

void Glom::LayoutGroup::add_item | ( | const sharedptr< LayoutItem >& | item,
|  | const sharedptr< const LayoutItem >& | position
| ) |  |

Add the item after the specified existing item.

Parameters

  item | The item to add.
  position | The item after which the item should be added.

virtual void Glom::LayoutGroup::change_field_item_name | ( | const Glib::ustring & | table_name,
|  | const Glib::ustring & | field_name,
|  | const Glib::ustring & | field_name_new
| ) |  |
| virtual

Reimplemented in Glom::LayoutItem_Portal, and Glom::LayoutItem_CalendarPortal.

virtual void Glom::LayoutGroup::change_related_field_item_name | ( | const Glib::ustring & | table_name,
|  | const Glib::ustring & | field_name,
|  | const Glib::ustring & | field_name_new
| ) |  |
| virtual

Reimplemented in Glom::LayoutItem_Portal, and Glom::LayoutItem_CalendarPortal.

virtual LayoutItem* Glom::LayoutGroup::clone | ( |  | ) | const
| virtual

Create a new copied instance.

This allows us to deep-copy a list of LayoutItems.

Implements Glom::LayoutItem.

Reimplemented in Glom::LayoutItem_Portal, Glom::LayoutItem_GroupBy, Glom::LayoutItem_Notebook, Glom::LayoutItem_Footer, Glom::LayoutItem_Header, Glom::LayoutItem_VerticalGroup, Glom::LayoutItem_Summary, and Glom::LayoutItem_CalendarPortal.

double Glom::LayoutGroup::get_border_width | ( |  | ) | const

guint Glom::LayoutGroup::get_columns_count | ( |  | ) | const

type_list_items Glom::LayoutGroup::get_items | ( |  | ) |

type_list_const_items Glom::LayoutGroup::get_items | ( |  | ) | const

guint Glom::LayoutGroup::get_items_count | ( |  | ) | const

type_list_const_items Glom::LayoutGroup::get_items_recursive | ( |  | ) | const

Get the items recursively, depth-first, not returning any groups.

type_list_items Glom::LayoutGroup::get_items_recursive | ( |  | ) |

Get the items recursively, depth-first, not returning any groups.

type_list_const_items Glom::LayoutGroup::get_items_recursive_with_groups | ( |  | ) | const

Get the items recursively, depth-first, also returning the groups.

This is only used by the tests so far.

virtual Glib::ustring Glom::LayoutGroup::get_part_type_name | ( |  | ) | const
| virtual

Implements Glom::LayoutItem.

Reimplemented in Glom::LayoutItem_GroupBy, Glom::LayoutItem_Notebook, Glom::LayoutItem_Footer, Glom::LayoutItem_Header, Glom::LayoutItem_VerticalGroup, Glom::LayoutItem_Summary, and Glom::LayoutItem_CalendarPortal.

virtual Glib::ustring Glom::LayoutGroup::get_report_part_id | ( |  | ) | const
| virtual

Gets the node name to use for the intermediate XML, (and usually, the CSS style class to use for the resulting HTML).

Reimplemented from Glom::LayoutItem.

Reimplemented in Glom::LayoutItem_GroupBy, Glom::LayoutItem_Footer, Glom::LayoutItem_Header, Glom::LayoutItem_VerticalGroup, and Glom::LayoutItem_Summary.

bool Glom::LayoutGroup::has_any_fields | ( |  | ) | const

Discover whether the layout group contains any fields.

Returns
  True if the field is in the layout group (or its child groups).

bool Glom::LayoutGroup::has_field | ( | const Glib::ustring & | parent_table_name,
|  | const Glib::ustring & | table_name,
|  | const Glib::ustring & | field_name
| ) |  | const

Discover whether the layout group contains the specified field (from the current table).

Parameters

  parent_table_name | The table to which this layout belongs.
  table_name | The table to which the field, specified by field_name, belongs.
  field_name | The name of the field to search for.

Returns
  True if the field is in the layout group (or its child groups).

LayoutGroup& Glom::LayoutGroup::operator= | ( | const LayoutGroup& | src | ) |

void Glom::LayoutGroup::remove_all_items | ( |  | ) |

void Glom::LayoutGroup::remove_field | ( | const Glib::ustring & | parent_table_name,
|  | const Glib::ustring & | table_name,
|  | const Glib::ustring & | field_name
| ) |  |

Remove any instance of the field from the layout.

Parameters

  parent_table_name | The table to which this layout belongs.
  table_name | The table to which the field, specified by field_name, belongs.
  field_name | The name of the field to remove.

void Glom::LayoutGroup::remove_item | ( | const sharedptr< LayoutItem >& | item | ) |

Remove a layout item from the group.

Parameters

  item | The item to remove.

virtual void Glom::LayoutGroup::remove_relationship | ( | const sharedptr< const Relationship >& | relationship | ) |
| virtual

Remove any use of the relationship from the layout.

void Glom::LayoutGroup::set_border_width | ( | double | border_width | ) |

void Glom::LayoutGroup::set_columns_count | ( | guint | columns_count | ) |

## Member Data Documentation

type_list_items Glom::LayoutGroup::m_list_items

The documentation for this class was generated from the following file:

- libglom/data_structure/layout/layoutgroup.h